#include "util.h"

#include <avr/interrupt.h>
#include <avr/io.h>

#include <util/delay.h>

#include <stdio.h>
#include <stdlib.h>


// ISR(PCINT1_vect)
// {
//     if ((PINB & (1 << PB2)) == 0)
//     {
//         PORTB |= (1 << PB3);

//         OCR1A -= 1000;
//         // Ma asigur ca OCR1B e mereu 1/4 din OCR1A
//         OCR1B = OCR1A/4;
//     }
// }

// ISR(PCINT3_vect)
// {
//     if ((PIND & (1 << PD6)) == 0)
//     {
//         PORTB &= ~(1 << PB3);

//         OCR1A += 1000;
//         // Ma asigur ca OCR1B e mereu 1/4 din OCR1A
//         OCR1B = OCR1A/4;
//     }
// }

/* intreruperea de comparatie cu OCR1A */
ISR(TIMER1_COMPA_vect)
{
    PORTB ^= (1 << PB1);
}


/* initializeaza intrarile si iesirile */
void IO_init()
{
    // butoanele sunt puse ca intrare, cu rezistenta de pull-up
    DDRB &= ~(1 << PB2);
    PORTB |= (1 << PB2);

    DDRB |= (1 << PB1);
    PORTB |= (1 << PB1);

    // Activez PIN CHANGE INTERRUPT ENABLE pentru PCINT15:8 (portul B) si PCINT24:31 (portul D)
    // Activez intreruperea pe butoanele PB2 si PD6
    // PCICR |= (1 << PCIE1) | (1 << PCIE3);
    // PCMSK1 |= (1 << PCINT10);
    // PCMSK3 |= (1 << PCINT30);
}

/* initializeaza timer-ul 1 */
void timer1_init()
{
    // Atribuim valoarea maxima pe 16 biti lui ICR1 pentru a putea genera OVF.  

    // OCR1A = 5000;

    // // activeaza intreruperea de comparare cu OCR1A
    // TIMSK1 = (1 << OCIE1A);
    // TCCR1B = (3 << CS10) | (1 << WGM12);
    TCCR0A = (1 << WGM01);
    TCCR0B = (1 << CS01);
    OCR0A = 0x50;
    TIMSK0 = (1 << OCIE0A);
}

int main(void)
{
    // initializari si testare interfeta afisare/debug
    //UI_init();
    // printf_init();
    // printf("USART ok\n");

    // _delay_ms(1000);

    // codul relevant laboratorului incepe aici
    //sei();

    ///timer1_init();
    //IO_init();

    DDRD = (1 << PD7);
    PORTD = (1 << PD7);

    DDRB &= ~(1 << PB2);
    PORTB |= (1 << PB2);

    DDRB |= (1 << PB1) | (1 << PB0);
    PORTB |= (1 << PB1);
    PORTB &= ~(1 << PB0);

    //timer1_init();
    //sei();

    while(1)
    {
        while ((PINB & (1 << PB2)) == 0) {
            PORTB |= (1 << PB1);
            _delay_us(500);
            PORTB ^= (1 << PB1);
            _delay_us(500);
            _delay_ms(50);
        } 

        while (PINB & (1 << PB2)) {
            PORTB |= (1 << PB0);
            PORTB |= (1 << PB1);
            _delay_us(500);
            PORTB ^= (1 << PB1);
            _delay_us(500);
            _delay_ms(50);


            PORTB  ^= (1 << PB0);
            PORTB |= (1 << PB1);
            _delay_us(500);
            PORTB ^= (1 << PB1);
            _delay_us(500);
        }

        // PORTB |= (1 << PB0);

        // for (uint8_t i = 0; i < 200; ++ i) {
        //     PORTB |= (1 << PB1);
        //     _delay_us(500);
        //     PORTB ^= (1 << PB1);
        //     _delay_us(500);
        // }

       

        // _delay_ms(400);


        // for (uint8_t i = 0; i < 200; ++ i) {
        //     PORTB |= (1 << PB1);
        //     _delay_us(500);
        //     PORTB ^= (1 << PB1);
        //     _delay_us(500);
        // }

        _delay_ms(400);
    }

    return 0;
}
